; # include < servo . h > 
; # asm 

; definitions

F      equ  1           ; declare destination options
W      equ  0

;----- STATUS Bits --------------------------------------------------------

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

GIE                          EQU     H'0007'
EEIE                         EQU     H'0006'
T0IE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
T0IF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'

;----- OPTION_REG Bits ----------------------------------------------------

NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
T0CS                         EQU     H'0005'
T0SE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'

;----- EECON1 Bits --------------------------------------------------------

EEIF                         EQU     H'0004'
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM H'CF'
        __BADRAM H'07', H'50'-H'7F', H'87'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_CP_ON                       EQU     H'000F'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_PWRTE_OFF                   EQU     H'3FFF'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'


       ;declare constants used by the compiler
       list p = 16F84a
       radix  decimal

       ; change config if needed
       __config  _HS_OSC & _WDT_OFF & _PWRTE_ON


       ;set up vectors
       org   0          ; reset vector
       call  init
_ml    call  main       ; loop
       goto  _ml
       org   4
       goto  _interupt  ; comment this out if you don't want interupts
                        ; otherwise supply a _interupt() C function

 ; -------------------- run time library  -------------------- */

        ; shifting, shift _temp with count in W
_rshift
        btfsc   STATUS,Z    
        return             ; ret if shift amount is zero
        bcf     STATUS,C   ; unsigned shift, mask bits
        rrf     _temp,F
        addlw   255        ; sub one
        goto    _rshift

_lshift
        btfsc   STATUS,Z    
        return             ; ret if shift amount is zero
        bcf     STATUS,C   ; arithmetic shift
        rlf     _temp,F
        addlw   255        ; sub one
        goto    _lshift

_eeadr                     ; set up EEDATA to contain desired data
        bcf     STATUS,RP0
        movwf   EEADR      ; correct address in W
        bsf     STATUS,RP0
        bsf     EECON1,RD
        bcf     STATUS,RP0
        return

DPV1
; # pragma pic 128 
; char IND2 ; 
	;data
IND2	equ 128
; char OPTION_REG ; 
OPTION_REG	equ 129
; char PCL2 ; 
PCL2	equ 130
; char STATUS2 ; 
STATUS2	equ 131
; char FSR2 ; 
FSR2	equ 132
; char TRISA ; 
TRISA	equ 133
; char TRISB ; 
TRISB	equ 134
; char _unused2 ; 
_unused2	equ 135
; char EECON1 ; 
EECON1	equ 136
; char EECON2 ; 
EECON2	equ 137
; char PCLATH2 ; 
PCLATH2	equ 138
; char INTCON2 ; 
INTCON2	equ 139
; # pragma pic 0 
; char INDF ; 
INDF	equ 0
; char TMR0 ; 
TMR0	equ 1
; char PCL ; 
PCL	equ 2
; char STATUS ; 
STATUS	equ 3
; char FSR ; 
FSR	equ 4
; char PORTA ; 
PORTA	equ 5
; char PORTB ; 
PORTB	equ 6
; char _unused ; 
_unused	equ 7
; char EEDATA ; 
EEDATA	equ 8
; char EEADR ; 
EEADR	equ 9
; char PCLATH ; 
PCLATH	equ 10
; char INTCON ; 
INTCON	equ 11
; char _temp ; 
_temp	equ 12
; # include < lcd . h > 
; # define RS 0x40 ; 
; # define RW 0x20 ; 
; # define E 0x10 ; 
; lcd_init ( ) { 
	;code
lcd_init
; lcd_fun ( 0x33 ) ; 
	movlw	51
	call	lcd_fun
; PORTB = PORTB | 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	iorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; PORTB = PORTB ^ 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	xorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; lcd_data ( 0x2 ) ; 
	movlw	2
	call	lcd_data
; PORTB = PORTB | 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	iorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; PORTB = PORTB ^ 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	xorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; lcd_fun ( 1 ) ; 
	movlw	1
	call	lcd_fun
; lcd_fun ( 0x14 ) ; 
	movlw	20
	call	lcd_fun
; lcd_fun ( 0x0e ) ; 
	movlw	14
	call	lcd_fun
; lcd_fun ( 0x80 ) ; 
	movlw	128
	call	lcd_fun
	return
; } 
; lcd_wr ( char dat ) { 
	;data
_lcd_wr	equ	13
	;code
lcd_wr
	movwf	_lcd_wr
; PORTB = 0x40 ;  ; 
	movlw	64
	bcf	STATUS,RP0
	movwf	PORTB
; lcd_wr2 ( dat ) ; 
	movf	_lcd_wr,W
	call	lcd_wr2
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
	return
; } 
; lcd_wr2 ( char dat ) { 
	;data
_lcd_wr2	equ	14
	;code
lcd_wr2
	movwf	_lcd_wr2
; lcd_data ( dat >> 4 ) ; 
	movf	_lcd_wr2,W
	movwf	_temp
	movlw	4
	call	_rshift
	movf	_temp,W
	call	lcd_data
; PORTB = PORTB | 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	iorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; PORTB = PORTB ^ 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	xorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; lcd_data ( dat ) ; 
	movf	_lcd_wr2,W
	call	lcd_data
; PORTB = PORTB | 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	iorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
; PORTB = PORTB ^ 0x10 ;  ; 
	bcf	STATUS,RP0
	movf	PORTB,W
	xorlw	16
	movwf	PORTB
; waitms ( 1 ) ; 
	movlw	1
	call	waitms
	return
; } 
; lcd_data ( char dat ) { 
	;data
_lcd_data	equ	15
	;code
lcd_data
	movwf	_lcd_data
; static char temp ; 
	;data
DPV2	equ 16
; temp = PORTB & 0xf0 ; 
	;code
	bcf	STATUS,RP0
	movf	PORTB,W
	andlw	240
	movwf	DPV2
; temp |= ( dat & 0xf ) ; 
	movf	_lcd_data,W
	andlw	15
	iorwf	DPV2,F
; PORTB = temp ; 
	movf	DPV2,W
	movwf	PORTB
	return
; } 
; lcd_fun ( char dat ) { 
	;data
_lcd_fun	equ	17
	;code
lcd_fun
	movwf	_lcd_fun
; PORTB = 0 ; 
	movlw	0
	bcf	STATUS,RP0
	movwf	PORTB
; lcd_wr2 ( dat ) ; 
	movf	_lcd_fun,W
	call	lcd_wr2
; waitms ( 2 ) ; 
	movlw	2
	call	waitms
	return
; } 
; void waitms ( char ms ) { 
	;data
_waitms	equ	18
	;code
waitms
	movwf	_waitms
; static char t2 ; 
	;data
DPV3	equ 19
; while ( ms ) { 
	;code
DPV4
	movf	_waitms,W
	btfsc	STATUS,Z
	goto	DPV5
; t2 = 200 ; 
	movlw	200
	movwf	DPV3
; while ( t2 ) { 
DPV6
	movf	DPV3,W
	btfsc	STATUS,Z
	goto	DPV7
; -- t2 ; 
	decf	DPV3,F
; # asm 
         nop
DPV8
; } -- ms ; 
	goto	DPV6
DPV7
	decf	_waitms,F
; } 
	goto	DPV4
DPV5
	return
; } 
; # define UP 0x08 
; # define DN 0x04 
; # define PULSE 0x10 
; # define LED1 0x8 
; # define LED2 0x4 
; # define LED3 0x2 
; char wtemp ; 
	;data
wtemp	equ 20
; char stemp ; 
stemp	equ 21
; char up ; 
up	equ 22
; char dn ; 
dn	equ 23
; char count ; 
count	equ 24
; char wcount ; 
wcount	equ 25
; char mcount ; 
mcount	equ 26
; char val [ 3 ] ; 
val	equ 27
; char step ; 
step	equ 30
; char dir ; 
dir	equ 31
; hex2ascii ( char dat ) { 
	;code
	;data
_hex2ascii	equ	32
	;code
hex2ascii
	movwf	_hex2ascii
; static char i ; 
	;data
DPV9	equ 33
; for ( i = 0 ; i < 3 ; ++ i ) val [ i ] = 0 ; 
	;code
	movlw	0
	movwf	DPV9
DPV10
	movf	DPV9,W
	addlw	253
	btfsc	STATUS,C
	goto	DPV12
	movf	DPV9,W
	addlw	val
	movwf	FSR
	movlw	0
	movwf	INDF
DPV11
; ++ i )  while ( dat >= 100 ) { 
	incf	DPV9,F
	goto	DPV10
DPV12
DPV13
	movf	_hex2ascii,W
	addlw	156
	btfss	STATUS,C
	goto	DPV14
; ++ val [ 0 ] ; 
	movlw	val+0
	movwf	FSR
	incf	INDF,F
; dat -= 100 ; 
	movlw	100
	subwf	_hex2ascii,F
; } 
	goto	DPV13
DPV14
; while ( dat >= 10 ) { 
DPV15
	movf	_hex2ascii,W
	addlw	246
	btfss	STATUS,C
	goto	DPV16
; ++ val [ 1 ] ; 
	movlw	val+1
	movwf	FSR
	incf	INDF,F
; dat -= 10 ; 
	movlw	10
	subwf	_hex2ascii,F
; } 
	goto	DPV15
DPV16
; val [ 2 ] = dat ; 
	movlw	val+2
	movwf	FSR
	movf	_hex2ascii,W
	movwf	INDF
; for ( i = 0 ; i < 3 ; ++ i ) val [ i ] += '0' ; 
	movlw	0
	movwf	DPV9
DPV17
	movf	DPV9,W
	addlw	253
	btfsc	STATUS,C
	goto	DPV19
	movf	DPV9,W
	addlw	val
	movwf	FSR
	movlw	48
	addwf	INDF,F
DPV18
; ++ i )  } 
	incf	DPV9,F
	goto	DPV17
DPV19
	return
; void tick ( ) { 
tick
; # asm 
    nop
    nop
    nop
DPV20
	return
; } _interupt ( ) { 
_interupt
; # asm 
   movwf   wtemp
   swapf   STATUS,W
   movwf   stemp
DPV21
; INTCON = 0x20 ; 
	movlw	32
	movwf	INTCON
; TMR0 = 178 ; 
	movlw	178
	bcf	STATUS,RP0
	movwf	TMR0
; wcount = count ; 
	movf	count,W
	movwf	wcount
; PORTA = 0x10  ; 
	movlw	16
	movwf	PORTA
; do { 
DPV22
; tick ( ) ; 
	call	tick
; } while ( -- wcount ) ; 
DPV23
	decfsz	wcount,F
;movf	wcount,W
;btfsc	STATUS,Z
;goto	DPV24
	goto	DPV22
DPV24
; PORTA = 0 ; 
	movlw	0
	bcf	STATUS,RP0
	movwf	PORTA
; if ( up ) count += 1 ; 
	movf	up,W
	btfsc	STATUS,Z
	goto	DPV25
	movlw	1
	addwf	count,F
; if ( dn ) count -= 1 ; 
DPV25
	movf	dn,W
	btfsc	STATUS,Z
	goto	DPV26
	movlw	1
	subwf	count,F
; up = 0 ; 
DPV26
;movlw	0
	clrf 	up
; dn = 0 ; 
;movlw	0
	clrf 	dn
; count += step ; 
	movf	step,W
	addwf	count,F
; step = 0 ; 
;movlw	0
	clrf 	step
; # asm 
   swapf   stemp,W
   movwf   STATUS
   swapf   wtemp,F
   swapf   wtemp,W
DPV27
	retfie
; } init ( ) { 
init
; up = 0 ; 
;movlw	0
	clrf 	up
; dn = 0 ; 
;movlw	0
	clrf 	dn
; count = 150 ; 
	movlw	150
	movwf	count
; mcount = 0 ; 
;movlw	0
	clrf 	mcount
; dir = 0 ; 
;movlw	0
	clrf 	dir
; step = 0 ; 
;movlw	0
	clrf 	step
; # asm 
     clrwdt
DPV28
; OPTION_REG = 0xc7 ; 
	movlw	199
	bsf	STATUS,RP0
	movwf	OPTION_REG
; TRISA = 0x0f ; 
	movlw	15
	movwf	TRISA
; TRISB = 0 ; 
;movlw	0
	clrf 	TRISB
; TMR0 = 178 ; 
	movlw	178
	bcf	STATUS,RP0
	movwf	TMR0
; PORTA = 0 ; 
;movlw	0
	clrf 	PORTA
; PORTB = 0xf ; 
	movlw	15
	movwf	PORTB
; lcd_init ( ) ; 
	call	lcd_init
; INTCON = 0xa0 ; 
	movlw	160
	movwf	INTCON
	return
; } 
; main ( ) { 
main
; static char temp ; 
	;data
DPV29	equ 34
; temp = PORTA ; 
	;code
	bcf	STATUS,RP0
	movf	PORTA,W
	movwf	DPV29
; up |= ( temp & 0x08  ) ^ 0x08  ; 
	movf	DPV29,W
	andlw	8
	xorlw	8
	iorwf	up,F
; dn |= ( temp & 0x04  ) ^ 0x04  ; 
	movf	DPV29,W
	andlw	4
	xorlw	4
	iorwf	dn,F
; temp = 0x8  + 0x4  + 0x2  ; 
	movlw	14
	movwf	DPV29
; if ( up ) temp ^= 0x4  ; 
	movf	up,W
	btfsc	STATUS,Z
	goto	DPV30
	movlw	4
	xorwf	DPV29,F
; if ( dn ) temp ^= 0x2  ; 
DPV30
	movf	dn,W
	btfsc	STATUS,Z
	goto	DPV31
	movlw	2
	xorwf	DPV29,F
; PORTB = temp ; 
DPV31
	movf	DPV29,W
	bcf	STATUS,RP0
	movwf	PORTB
; if ( count != mcount ) { 
	movf	count,W
	movwf	_temp
	movf	mcount,W
	subwf	_temp,W
	btfsc	STATUS,Z
	goto	DPV32
; mcount = count ; 
	movf	count,W
	movwf	mcount
; hex2ascii ( count ) ; 
	movf	count,W
	call	hex2ascii
; lcd_fun ( 0x80 ) ; 
	movlw	128
	call	lcd_fun
; lcd_wr ( val [ 0 ] ) ; 
	movlw	val+0
	movwf	FSR
	movf	INDF,W
	call	lcd_wr
; lcd_wr ( '.' ) ; 
	movlw	46
	call	lcd_wr
; lcd_wr ( val [ 1 ] ) ; 
	movlw	val+1
	movwf	FSR
	movf	INDF,W
	call	lcd_wr
; lcd_wr ( val [ 2 ] ) ; 
	movlw	val+2
	movwf	FSR
	movf	INDF,W
	call	lcd_wr
; lcd_wr ( ' ' ) ; 
	movlw	32
	call	lcd_wr
; lcd_wr ( 'm' ) ; 
	movlw	109
	call	lcd_wr
; lcd_wr ( 's' ) ; 
	movlw	115
	call	lcd_wr
; } 
; temp = PORTA & 3 ; 
DPV32
	bcf	STATUS,RP0
	movf	PORTA,W
	andlw	3
	movwf	DPV29
; if ( temp != 3 && dir == 0 ) { 
	movf	DPV29,W
	addlw	253
	btfsc	STATUS,Z
	goto	DPV33
	movf	dir,W
;addlw	256
	btfss	STATUS,Z
	goto	DPV33
; dir = ( temp == 1 ) ? 0x08  : 0x04  ; 
	movf	DPV29,W
	addlw	255
	btfss	STATUS,Z
	goto	DPV34
	movlw	8
	iorlw	0
	goto	DPV35
DPV34
	movlw	4
	iorlw	0
DPV35
	movwf	dir
; } 
; if ( temp == 3 && dir != 0 ) { 
DPV33
	movf	DPV29,W
	addlw	253
	btfss	STATUS,Z
	goto	DPV36
	movf	dir,W
	addlw	256
	btfsc	STATUS,Z
	goto	DPV36
; step = ( dir == 0x08  ) ? 10 : - 10 ; 
	movf	dir,W
	addlw	248
	btfss	STATUS,Z
	goto	DPV37
	movlw	10
	iorlw	0
	goto	DPV38
DPV37
	movlw	-10
	iorlw	0
DPV38
	movwf	step
; dir = 0 ; 
;movlw	0
	clrf 	dir
; } 
; } 
DPV36
	return
	end
